﻿@using FinalProject.Entity;
@{
    ViewBag.Title = "Index";
    var account = ViewBag.Account as Accounts;
    var balance = ViewBag.Balance as Balances;
}
<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Home page
        <small>it all starts here</small>
    </h1>
    <ol class="breadcrumb">
        <li class="active">Home page</li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <!-- Default box -->
    <div class="box">
        <div class="box-header with-border">
            <h3 class="box-title">Dashboard</h3>
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                        title="Collapse">
                    <i class="fa fa-minus"></i>
                </button>
                <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                    <i class="fa fa-times"></i>
                </button>
            </div>
        </div>
        <div class="box-body">
            <h3>Welcome to Fintech Application MVC, @account.FirstName</h3>
            <h3 class="text-blue">Your Active Ballance <span style="font-size:18px;" class="badge bg-yellow">Rp.@balance.Balance.ToString("##,###.00")</span></h3>
            <div class="row">
                <div class="col-md-6">
                    <h4 style="font-weight: 500">Pending TopUp</h4>
                    <table class="table table-bordered">
                        <thead>
                            <tr>
                                <td></td>
                                <td>TopUP Date</td>
                                <td>Bank ID</td>
                                <td>Bank Name</td>
                                <td>Amount</td>
                            </tr>
                        </thead>
                        <tbody>
                            <tr ng-repeat="p in topups">
                                <td>
                                    <a ng-click="processTopup(p)" style="font-size: 1.2em; color: red"><i class="fa fa-hourglass"></i></a>
                                </td>
                                <td ng-bind="p.TopupID"></td>
                                <td ng-bind="p.BankID">100</td>
                                <td ng-bind="p.BankName">BCA</td>
                                <td ng-bind="p.Amount" class="text-right">15.000</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="col-md-6">
                    <h4 style="font-weight: 500">Pending Transactions</h4>
                    <table class="table  table-bordered">
                        <thead>
                            <tr>
                                <td></td>
                                <td>Transaction ID</td>
                                <td>Transaction Date</td>
                                <td>Merchant</td>
                                <td>Amount</td>
                            </tr>
                        </thead>
                        <tbody>
                            <tr ng-repeat="t in txns">
                                <td>
                                    <a ng-click="processTxn(t)" style="font-size: 1.2em; color: red"><i class="fa fa-hourglass"></i></a>
                                </td>
                                <td ng-bind="t.TransactionID"></td>
                                <td ng-bind="t.MerchantID">2019-Jun-12</td>
                                <td ng-bind="t.MerchantName">Cafe Tunggu</td>
                                <td ng-bind="t.Amount" class="text-right">15.000</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <!-- /.box-body -->
        <div class="box-footer"></div>
        <!-- /.box-footer-->
    </div>
    <!-- /.box -->
</section>
<!-- /.content -->
@section scripts{
    <script>
        (function () {

            angular.module("fintech-app").controller("ctrl", controller);

            function controller($scope, $http) {
                var scope = $scope;
                var http = $http;

                scope.topups = [];
                scope.txns = [];
                scope.topup = {};
                scope.txn = {};
                loadTopup();
                loadTxn();

                function loadTopup() {
                    http({
                        url: '/Default/PendingTopup',
                        method: 'POST',
                        data: {
                            page: { page: 1, pageSize: 100, criteria: [], order: 'TopupID ASC' }
                        }
                    }).then(function (res) { return res.data; }).then(function (res) { scope.topups = res.data.Rows; });
                }

                function loadTxn() {
                    http({
                        url: '/Default/PendingTxn',
                        method: 'POST',
                        data: {
                            page: { page: 1, pageSize: 100, criteria: [], order: 'TransactionID ASC' }
                        }
                    }).then(function (res) { return res.data; }).then(function (res) { scope.txns = res.data.Rows; });
                }




                scope.processTopup = function processTopup(obj) {
                    scope.topup = obj;
                    $("#topup-detail").modal({ backdrop: 'static' });
                    console.log(obj);
                }

                scope.processTxn = function processTxn(obj) {
                    scope.txn = obj;
                    $("#txn-detail").modal({ backdrop: 'static' });
                    console.log(obj);
                }

                scope.acceptTopup = function () {
                    var opt = {
                        url: '/Topup/Accepted', method: 'POST', data: { id: scope.topup.TopupID }
                    };
                    http(opt).then(function (res) { return res.data; })
                        .then(function (res) {
                            if (res.meta.success) {
                                Swal.fire('Success', 'Accept Topup Success', 'success').then(function (r) {
                                    location.reload();
                                })
                            } else {
                                Swal.fire('Error', res.meta.message, 'error')
                            }
                        });
                }

                scope.rejectTopup = function () {
                    var opt = {
                        url: '/Topup/Rejected', method: 'POST', data: { id: scope.topup.TopupID }
                    };
                    http(opt).then(function (res) { return res.data; })
                        .then(function (res) {
                            if (res.meta.success) {
                                Swal.fire('Success', 'Reject Topup Success', 'success').then(function (r) {
                                    location.reload();
                                })
                            } else {
                                Swal.fire('Error', res.meta.message, 'error')
                            }
                        });
                }

                scope.acceptTxn = function () {
                    var opt = {
                        url: '/Transaction/Accepted', method: 'POST', data: { id: scope.txn.TransactionID }
                    };
                    http(opt).then(function (res) { return res.data; })
                        .then(function (res) {
                            if (res.meta.success) {
                                Swal.fire('Success', 'Accept Transaction Success', 'success').then(function (r) {
                                    location.reload();
                                })
                            } else {
                                Swal.fire('Error', res.meta.message, 'error')
                            }
                        });
                }

                scope.rejectTxn = function () {
                    var opt = {
                        url: '/Transaction/Rejected', method: 'POST', data: { id: scope.txn.TransactionID }
                    };
                    http(opt).then(function (res) { return res.data; })
                        .then(function (res) {
                            if (res.meta.success) {
                                Swal.fire('Success', 'Reject Transaction Success', 'success').then(function (r) {
                                    location.reload();
                                })
                            } else {
                                Swal.fire('Error', res.meta.message, 'error')
                            }
                        });
                }
            }

            setTimeout(function () { $("[content]").css("opacity", 1); }, 100);
            $("[dashboard]").addClass("active");
        }());
    </script>
}

